
Ruby - Bug #13112

io/console io.winsize=[rows,cols] throws TypeError: no implicit conversion of false into Integer

01/07/2017 06:19 AM - tompng (tomoya ishida)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.4.0p0 (2016-12-24 revision

57164) [x86_64-darwin16]

Backport: 2.2: DONTNEED, 2.3: DONE, 2.4:

DONE

Description

The doc says

winsize = [rows, columns]

Tries to set console size. The effect depends on the platform and the running environment.

You must require 'io/console' to use this method.

https://docs.ruby-lang.org/en/2.4.0/IO.html#method-i-winsize-3D

 but it doesn't work.

require 'io/console'

STDIN.winsize=[] #=> ArgumentError: wrong number of arguments (given 0, expected 2..4)

STDIN.winsize=[24,80,1,2] #=> ok(args=4)

STDIN.winsize=[24,80,nil,nil] #=> ok(args=4)

STDIN.winsize=[24,80,1] #=> ok(args=3)

STDIN.winsize=[24,80,nil] #=> ok(args=3)

STDIN.winsize=[24,80] 

#=> args=2 unexpectedly throws TypeError: no implicit conversion of false into Integer

 
OS: macOS Sierra 10.12.2

versions:

ruby 2.4.0 -> TypeError

ruby 2.3.1 -> TypeError

ruby 2.0.0 -> ok

 
// ext/io/console/console.c

static VALUE

console_set_winsize(VALUE io, VALUE size)

{

    ....

    size = rb_Array(size);

    rb_check_arity(RARRAY_LENINT(size), 2, 4);

    sz = RARRAY_CONST_PTR(size);

    row = sz[0], col = sz[1], xpixel = sz[2], ypixel = sz[3];

    ...

    #define SET(m) ws.ws_##m = NIL_P(m) ? 0 : (unsigned short)NUM2UINT(m)

    SET(row);

    SET(col);

    SET(xpixel);

    SET(ypixel);

    // is using xpixel(==sz[2]) and ypixel(==sz[3]) ok? (RARRAY_LENINT(size) might be less than 4)

    // maybe sz[3] is 0(object_id of false?) when RARRAY_LENINT(size) is 2

Associated revisions

Revision 5b856ee1a620f965dad6eaad759cfc23e5d697d6 - 01/07/2017 10:52 PM - nobu (Nobuyoshi Nakada)

console.c: OOB access

ext/io/console/console.c (console_set_winsize): fix

out-of-bounds access.  [ruby-core:79004] [Bug #13112]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@57280 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 5b856ee1 - 01/07/2017 10:52 PM - nobu (Nobuyoshi Nakada)

console.c: OOB access

ext/io/console/console.c (console_set_winsize): fix

out-of-bounds access.  [ruby-core:79004] [Bug #13112]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@57280 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 00d2e368313627b183902090849d870ec9c11ee4 - 03/11/2017 02:59 PM - naruse (Yui NARUSE)

merge revision(s) 57280,57282: [Backport #13112]

    console.c: OOB access

    * ext/io/console/console.c (console_set_winsize): fix

      out-of-bounds access.  [ruby-core:79004] [Bug #13112]

    console.c: unpaired size

    * ext/io/console/console.c (console_set_winsize): reject unpaired

      pixel size.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@57849 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 00d2e368 - 03/11/2017 02:59 PM - naruse (Yui NARUSE)

merge revision(s) 57280,57282: [Backport #13112]

    console.c: OOB access

    * ext/io/console/console.c (console_set_winsize): fix

      out-of-bounds access.  [ruby-core:79004] [Bug #13112]

    console.c: unpaired size

    * ext/io/console/console.c (console_set_winsize): reject unpaired

      pixel size.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@57849 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision e0cb040a9b034cff481d7660dc59ce060777d6b1 - 03/27/2017 02:35 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 57280,57282: [Backport #13112]

    console.c: OOB access

    * ext/io/console/console.c (console_set_winsize): fix

      out-of-bounds access.  [ruby-core:79004] [Bug #13112]

    console.c: unpaired size

    * ext/io/console/console.c (console_set_winsize): reject unpaired

      pixel size.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@58151 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision e0cb040a - 03/27/2017 02:35 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 57280,57282: [Backport #13112]

    console.c: OOB access

    * ext/io/console/console.c (console_set_winsize): fix

      out-of-bounds access.  [ruby-core:79004] [Bug #13112]

    console.c: unpaired size

    * ext/io/console/console.c (console_set_winsize): reject unpaired

      pixel size.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@58151 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 5264f6d848f74309fdef606e0c043b053bee52ef - 03/27/2017 10:31 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 57289: [Backport #13112]

    test_io_console.rb: fix of old CentOS5

    * test/io/console/test_io_console.rb (test_winsize): on old CentOS5
      window size seems unable to be set across a pty.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@58189 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 5264f6d8 - 03/27/2017 10:31 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 57289: [Backport #13112]

    test_io_console.rb: fix of old CentOS5

    * test/io/console/test_io_console.rb (test_winsize): on old CentOS5

      window size seems unable to be set across a pty.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@58189 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 01/07/2017 10:52 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset r57280.

console.c: OOB access

ext/io/console/console.c (console_set_winsize): fix

out-of-bounds access.  [ruby-core:79004] [Bug #13112]

#2 - 01/07/2017 11:02 PM - nobu (Nobuyoshi Nakada)

- Description updated

- Backport changed from 2.2: UNKNOWN, 2.3: UNKNOWN, 2.4: UNKNOWN to 2.2: DONTNEED, 2.3: REQUIRED, 2.4: REQUIRED

#3 - 03/11/2017 02:59 PM - naruse (Yui NARUSE)

- Backport changed from 2.2: DONTNEED, 2.3: REQUIRED, 2.4: REQUIRED to 2.2: DONTNEED, 2.3: REQUIRED, 2.4: DONE

ruby_2_4 r57849 merged revision(s) 57280,57282.

#4 - 03/27/2017 02:35 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.2: DONTNEED, 2.3: REQUIRED, 2.4: DONE to 2.2: DONTNEED, 2.3: DONE, 2.4: DONE

ruby_2_3 r58151 merged revision(s) 57280,57282.

#5 - 03/27/2017 10:28 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.2: DONTNEED, 2.3: DONE, 2.4: DONE to 2.2: DONTNEED, 2.3: REQUIRED, 2.4: DONE

#6 - 03/27/2017 10:31 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.2: DONTNEED, 2.3: REQUIRED, 2.4: DONE to 2.2: DONTNEED, 2.3: DONE, 2.4: DONE

ruby_2_3 r58189 merged revision(s) 57289.
